package jettyTiddlywiki.entity;

import java.util.Date;

import jettyTiddlywiki.factory.B32F;
import jettyTiddlywiki.factory.TSRF;
import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.toolbox.Miscellaneous;

public class Tidder {
	private String html;
	private String raw;
	private String name;
	private String key;//base32 of name
	private String timeStamp;//yyyyMMddHHmmssSSS
	
	public Tidder(String name, String raw){
		this.name = name;
		this.html = TSRF.get().parse(raw,URCF.encode(name));
		this.raw = raw;
		this.timeStamp = Miscellaneous.INSTANCE.defsdf.format(new Date());
		this.key = B32F.get().encodeToString(name.getBytes());
	}
	
	public Tidder(String key, String name, String html, String raw, String timestamp){
		this.name = name;
		this.html = html;
		this.raw = raw;
		this.timeStamp = timestamp;
		this.key = key;
	}

	public String getHtml() {
		return html;
	}

	public void setHtml(String html) {
		this.html = html;
	}

	public String getRaw() {
		return raw;
	}

	public void setRaw(String raw) {
		this.raw = raw;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public String getTimeStamp() {
		return timeStamp;
	}

	public void setTimeStamp(String timeStamp) {
		this.timeStamp = timeStamp;
	}
}