package jettyTiddlywiki.io;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import jettyTiddlywiki.entity.Diff;
import jettyTiddlywiki.factory.CNF;


public class DiffIO {
	
	public static void writeDiff(Diff d) {
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        stat.executeUpdate("CREATE TABLE IF NOT EXISTS diffs (key varchar(128) PRIMARY KEY ASC, name varchar(128), html text);");
	        final PreparedStatement prep = con.prepareStatement("INSERT OR REPLACE into diffs VALUES (?,?,?);");
	        prep.setString(1, d.getKey());
	        prep.setString(2, d.getWiki());
	        prep.setString(3, d.getHtml());
	        prep.addBatch();
	        con.setAutoCommit(false);
	        prep.executeBatch();
	        con.setAutoCommit(true);
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static Diff readDiff(String key){
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT * from diffs where key='"+key+"';");
	        if(!res.next())return null;
	        else{
	        	return new Diff(res.getString("key"), res.getString("name"), res.getString("html"));
	        }
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void init(){
		try {
			CNF.get().createStatement().executeUpdate("CREATE TABLE IF NOT EXISTS diffs (key varchar(128) PRIMARY KEY ASC, name varchar(128), html text);");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
