package jettyTiddlywiki.io;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import jettyTiddlywiki.entity.File;
import jettyTiddlywiki.factory.B32F;
import jettyTiddlywiki.factory.CNF;


public class FileIO {
	
	public class MetaData{
		private final String name;
		private final String wiki;
		private final String type;
		private final int size;
		public MetaData(String name,String wiki,String type,int size){
			this.name = name;
			this.wiki = wiki;
			this.type = type;
			this.size = size;
		}
		public String getName() {
			return name;
		}
		public String getWiki() {
			return wiki;
		}
		public String getType() {
			return type;
		}
		public int getSize() {
			return size;
		}
	}
	
	public List<MetaData> ls(String wiki){
		List<MetaData> fs = new ArrayList<MetaData>();
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT name,wiki,type,size from files where wikikey=='" + B32F.get().encodeToString(wiki.getBytes()) + "';");
	        while(res.next()){
	        	fs.add(new MetaData(res.getString("name"), res.getString("wiki"), res.getString("type"), res.getInt("size")));
	        }
	        return fs;
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void writeFile(File f) {
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        stat.executeUpdate("CREATE TABLE IF NOT EXISTS files (key varchar(128) PRIMARY KEY ASC, name varchar(128), wiki varchar(128), wikikey varchar(128), type varchar(128), size integer, bl blob);");
	        stat.executeUpdate("CREATE INDEX IF NOT EXISTS idx_file ON files (wikikey) ");
	        final PreparedStatement prep = con.prepareStatement("INSERT OR REPLACE into files VALUES (?,?,?,?,?,?,?);");
	        prep.setString(1, f.getKey());
	        prep.setString(2, f.getName());
	        prep.setString(3, f.getWiki());
	        prep.setString(4, f.getWikikey());
	        prep.setString(5, f.getCtyp());
	        prep.setInt(6, f.getSize());
	        prep.setBytes(7, f.getByts());
	        prep.addBatch();
	        con.setAutoCommit(false);
	        prep.executeBatch();
	        con.setAutoCommit(true);
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static File readFile(String key){
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT * from files where key='"+key+"';");
	        if(!res.next())return null;
	        else{
	        	return new File(res.getString("name"), res.getString("wiki"), res.getString("wikikey"),res.getString("key"),res.getString("type"),res.getBytes("bl"),res.getInt("size"));
	        }
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void init(){
		try {
			Statement stat = CNF.get().createStatement();
			stat.executeUpdate("CREATE TABLE IF NOT EXISTS files (key varchar(128) PRIMARY KEY ASC, name varchar(128), wiki varchar(128), wikikey varchar(128), type varchar(128), size integer, bl blob);");
			stat.executeUpdate("CREATE INDEX IF NOT EXISTS idx_file ON files (wikikey) ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
