package jettyTiddlywiki.io;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;


import jettyTiddlywiki.entity.Tidder;
import jettyTiddlywiki.factory.CNF;
import jettyTiddlywiki.toolbox.Miscellaneous;


public class TidderIO {
	public class MetaData{
		private final String name;
		private final String timestamp;
		public MetaData(String name,String timestamp){
			this.name = name;
			this.timestamp = timestamp;
		}
		public String getName() {
			return name;
		}
		public String getTimestamp() {
			return timestamp;
		}
	}
	
	public List<MetaData> ls(){
		List<MetaData> ts = new ArrayList<MetaData>();
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT name,timestamp from tidders ORDER BY timestamp DESC limit 16;");
	        while(res.next()){
	        	ts.add(new MetaData(res.getString("name"), res.getString("timestamp")));
	        }
	        return ts;
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public class MetaDataSearch{
		private final String name;
		private final String raw;
		public MetaDataSearch(String name,String raw){
			this.name = name;
			this.raw = raw;
		}
		public String getName() {
			return name;
		}
		public String getRaw() {
			return raw;
		}
	}
	
	public List<MetaDataSearch> search(String keyword){
		List<MetaDataSearch> ts = new ArrayList<MetaDataSearch>();
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT name,raw from tidders where name like '%"+Miscellaneous.INSTANCE.sqliteEscape(keyword)+"%' OR raw like '%"+Miscellaneous.INSTANCE.sqliteEscape(keyword)+"%' limit 24;");
	        while(res.next()){
	        	ts.add(new MetaDataSearch(res.getString("name"), res.getString("raw")));
	        }
	        return ts;
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void writeTidder(Tidder t) {
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        stat.executeUpdate("CREATE TABLE IF NOT EXISTS tidders (key varchar(128) PRIMARY KEY ASC, name varchar(128), html text, raw text, timestamp varchar(16));");
	        stat.executeUpdate("CREATE INDEX IF NOT EXISTS idx_tidder ON tidders (timestamp) ");
	        final PreparedStatement prep = con.prepareStatement("INSERT OR REPLACE into tidders VALUES (?,?,?,?,?);");
	        prep.setString(1, t.getKey());
	        prep.setString(2, t.getName());
	        prep.setString(3, t.getHtml());
	        prep.setString(4, t.getRaw());
	        prep.setString(5, t.getTimeStamp());
	        prep.addBatch();
	        con.setAutoCommit(false);
	        prep.executeBatch();
	        con.setAutoCommit(true);
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static Tidder readTidder(String key){
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        final ResultSet res = stat.executeQuery("SELECT * from tidders where key='"+key+"';");
	        if(!res.next())return null;
	        else{
	        	return new Tidder(res.getString("key"), res.getString("name"), res.getString("html"), res.getString("raw"), res.getString("timestamp"));
	        }
	    	//CNF.close(con);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void init(){
		try {
			Connection con = CNF.get();
	        final Statement stat = con.createStatement();
	        stat.executeUpdate("CREATE TABLE IF NOT EXISTS tidders (key varchar(128) PRIMARY KEY ASC, name varchar(128), html text, raw text, timestamp varchar(16));");
	        stat.executeUpdate("CREATE INDEX IF NOT EXISTS idx_tidder ON tidders (timestamp) ");
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}
