package jettyTiddlywiki.response;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public enum AbnormalPrinter {

	Singleton;
	
    public void print(final HttpServletResponse res, final HttpServletRequest req, ResCode code)
    {
        try
        {
            res.setStatus(code.code);
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write("<head><title>"+code.name()+"</title></head>\n");
            out.write("<body>\n<h1>"+code.name()+"</h1>\n<pre>\n"+req.toString()+"\n</pre>\n</body>");
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
    
    public enum ResCode{
    	Forbidden(403), Unauthorized(401), NotFound(404), BadRequest(400), MethodNotAllowed(405);
    	private ResCode(int code){
    		this.code = code;
    	}
    	final int code;
    }
}
