package jettyTiddlywiki.servlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.io.FileIO;
import jettyTiddlywiki.io.FileIO.MetaData;
import jettyTiddlywiki.url.URLHandler;
import jettyTiddlywiki.url.URLHandler.PC;


public class Atms extends HttpServlet{
	
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
        if(!URLHandler.INSTANCE.handle(req, res, PC.Attachment)){
        	return;
        }
        atms(res, new File(req.getPathInfo()).getName());
    }

    private void atms(final HttpServletResponse res, final String s)
    {
    	List<FileIO.MetaData> fs = new FileIO().ls(s);
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write("<table>");
            for (final MetaData f : fs)
            {
                final String purl = "/file/" + URCF.encode(f.getWiki()) + "/" + URCF.encode(f.getName());
                final String preview = (f.getType().startsWith("image")) ? "<img src=\"" + purl + "\" width='200px' height='200px' />" : "";
                out.write("<tr>" + "<th>" + "<ul><li><a href=\"" + purl + "\" style='display:block;'>" + f.getName() + "</a></li><li>" + "/file/"+f.getWiki()+"/"+f.getName() + "</li>" + "<li>" + f.getType() + "</li><li>" + Integer.toString(f.getSize()) + "Bytes</li></ul>" + "</th><td>" + preview + "</td></tr>");
            }
            out.write("</table>");
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
