package jettyTiddlywiki.servlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.factory.B32F;
import jettyTiddlywiki.io.DiffIO;
import jettyTiddlywiki.response.AbnormalPrinter;
import jettyTiddlywiki.response.AbnormalPrinter.ResCode;
import jettyTiddlywiki.url.URLHandler;
import jettyTiddlywiki.url.URLHandler.PC;


public class Diff extends HttpServlet{
	
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	 if(!URLHandler.INSTANCE.handle(req, res, PC.Diff)){
         	return;
         }
         diff(res, req, new File(req.getPathInfo()).getName());
    }

    private void diff(final HttpServletResponse res, final HttpServletRequest req, final String s)
    {
    	jettyTiddlywiki.entity.Diff _or = DiffIO.readDiff(B32F.get().encodeToString(s.getBytes()));
    	if (_or == null)
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
        }
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write(_or.getHtml());
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
