package jettyTiddlywiki.servlet;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Date;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.factory.B32F;
import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.io.FileIO;
import jettyTiddlywiki.response.AbnormalPrinter;
import jettyTiddlywiki.response.AbnormalPrinter.ResCode;
import jettyTiddlywiki.url.URLHandler;
import jettyTiddlywiki.url.URLHandler.PC;

import org.apache.commons.io.IOUtils;

import com.oreilly.servlet.multipart.FilePart;
import com.oreilly.servlet.multipart.MultipartParser;
import com.oreilly.servlet.multipart.ParamPart;
import com.oreilly.servlet.multipart.Part;

public class File extends HttpServlet{
    @Override
    public void doPost(final HttpServletRequest req, final HttpServletResponse res)
    {
        String na = null;
        String wi = null;
        String co = null;
        byte[] b  = null;
        try
        {
            final MultipartParser p = new MultipartParser(req, 10000000, false, false, "UTF-8");
            Part pa;
            while ((pa = p.readNextPart()) != null)
            {
                if (pa.isParam() && pa.getName().equals("wiki"))
                {
                    wi = URCF.decode(((ParamPart) pa).getStringValue());
                }
                else if (pa.isFile())
                {
                    final FilePart fp = ((FilePart) pa);
                    na = (fp.getFileName() == null) ? Long.toString(new Date().getTime()) + "." + fp.getContentType().substring(fp.getContentType().lastIndexOf('/') + 1) : fp.getFileName();
                    co = fp.getContentType();
                    b = IOUtils.toByteArray(fp.getInputStream());
                }
            }
            if ((wi != null) && (b != null))
            {
                final jettyTiddlywiki.entity.File f = new jettyTiddlywiki.entity.File(na, wi, co, b);
                FileIO.writeFile(f);
            }
            else{
            	AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
            }
        }
        catch (final IOException e1)
        {
            e1.printStackTrace();
        }
    }
    
    @Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	if(!URLHandler.INSTANCE.handle(req, res, PC.File)){
         	return;
        }
        final java.io.File tmpf = new java.io.File(req.getPathInfo());
        ResponseFile(tmpf.getParentFile().getName() + "/" + tmpf.getName(), res , req);
    }

    private void ResponseFile(final String fname, final HttpServletResponse res, final HttpServletRequest req)
    {
    	jettyTiddlywiki.entity.File _f = FileIO.readFile(B32F.get().encodeToString(fname.getBytes()));
    	if (_f == null)
    	{
    		AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
    	}

		try {
			OutputStream out = res.getOutputStream();
			res.setContentType(_f.getCtyp());	
			out.write(_f.getByts());
	        out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}       
    }
}
