package jettyTiddlywiki.servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.factory.TSRF;
import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.response.AbnormalPrinter;
import jettyTiddlywiki.response.AbnormalPrinter.ResCode;


public class Parse extends HttpServlet
{
    @Override
    public void doPost(final HttpServletRequest req, final HttpServletResponse res)
    {
        if (req.getParameter("raw") == null)
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
        }
        final String raw = req.getParameter("raw").replaceAll("\r\n?", "\n");
        final String wiki_title_encoded = req.getParameter("wiki");
        final String html = TSRF.get().parse(raw,wiki_title_encoded);
        try
        {
            res.setContentType("text/html");
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write(html);
            out.flush();
            out.close();
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
