package jettyTiddlywiki.servlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.entity.Tidder;
import jettyTiddlywiki.factory.B32F;
import jettyTiddlywiki.io.TidderIO;
import jettyTiddlywiki.response.AbnormalPrinter;
import jettyTiddlywiki.response.AbnormalPrinter.ResCode;
import jettyTiddlywiki.url.URLHandler;


public class Raw extends HttpServlet{
    
	@Override
    public void doGet(final HttpServletRequest req, final HttpServletResponse res)
    {
    	if (!URLHandler.INSTANCE.handle(req, res, URLHandler.PC.Raw)) return;
    	raw(res, new File(req.getPathInfo()).getName(), req);
    }
    
    private void raw(final HttpServletResponse res, final String s, final HttpServletRequest req)
    {
        Tidder _or = TidderIO.readTidder(B32F.get().encodeToString(s.getBytes()));
        if (_or == null)
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.NotFound);
            return;
        }
        try
        {
        	String raw = _or.getRaw();
        	if(raw.startsWith("<!--{{{-->")){
        		res.setContentType("text/html");
        	}else if(raw.startsWith("/*{{{*/")){
        		res.setContentType("text/css");
        	}else{
        		res.setContentType("text/plain");        		
        	}
            res.setCharacterEncoding("UTF-8");
            final PrintWriter out = res.getWriter();
            out.write(raw);
        }
        catch (final IOException e)
        {
            e.printStackTrace();
        }
    }
}
