package jettyTiddlywiki.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.io.TidderIO;
import jettyTiddlywiki.toolbox.Miscellaneous;

 
public class Recent extends HttpServlet
{
	 public void doGet(final HttpServletRequest req, final HttpServletResponse res)
	 {
	    	 List<TidderIO.MetaData> ts = new TidderIO().ls();
	         try
	         {
	             res.setContentType("text/html");
	             res.setCharacterEncoding("UTF-8");
	             final PrintWriter out = res.getWriter();
	             out.write("<ul id='recent'>");
	             for (final TidderIO.MetaData t : ts)
	             {
	            	 cal.setTime(Miscellaneous.INSTANCE.defsdf.parse(t.getTimestamp()));
	                 out.write("<li timestamp='"+t.getTimestamp()+"'><a href=\"/wiki/"+URCF.encode(t.getName())+"\"><div class='timestamp'><span class='month'>" + MONTH[cal.get(Calendar.MONTH)] + "</span><span class='date'>" + cal.get(Calendar.DAY_OF_MONTH) + "</span></div><span class='wiki'>" + t.getName()+ "</span></a></li>");
	             }
	             out.write("</ul>");
	         }
	         catch (final IOException e)
	         {
	             e.printStackTrace();
	         } catch (ParseException e) {
				e.printStackTrace();
			}
	    }
	    
	    private Calendar cal = new GregorianCalendar();
	    private final static String[] MONTH = new String[]{"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
}