package jettyTiddlywiki.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import jettyTiddlywiki.factory.URCF;
import jettyTiddlywiki.io.TidderIO;
import jettyTiddlywiki.io.TidderIO.MetaDataSearch;
import jettyTiddlywiki.toolbox.Miscellaneous;

public class Search  extends HttpServlet
{	
	public void doGet(final HttpServletRequest req, final HttpServletResponse res)
	{
		final String keyword = req.getParameter("keyword");
		if(keyword == null || keyword.isEmpty()) return;
		List<TidderIO.MetaDataSearch> ts = new TidderIO().search(keyword);

	    try
	    {
	        res.setContentType("text/html");
	        res.setCharacterEncoding("UTF-8");
	        final PrintWriter out = res.getWriter();
	        if(ts.size()==0){
	        	out.write("no results found. keyword:\""+keyword+"\"");
	        	return;
	        }
	        out.write("<dl id='search_result'>\n");
	 		for (MetaDataSearch metaDataSearch : ts) {
	 			out.write("<dt><a href='"+URCF.encode(metaDataSearch.getName())+"'>"+Miscellaneous.INSTANCE.htmlEncode(metaDataSearch.getName()).replaceAll("(?i)"+keyword, "<span class='keyword'>$0</span>")+"</a></dt>\n");
				String raw = metaDataSearch.getRaw();
 	 			int position = raw.toLowerCase().indexOf(keyword.toLowerCase());
 	 			String str = (position < 30)? raw : "..."+raw.substring(position-12);
 	 			String ret = (str.length() < 360)?Miscellaneous.INSTANCE.htmlEncode(str).replaceAll("(?i)"+keyword,"<span class='keyword'>$0</span>"):Miscellaneous.INSTANCE.htmlEncode(str.substring(0,360)).replaceAll("(?i)"+keyword,"<span class='keyword'>$0</span>")+"...";
 	 			out.write("<dd>"+ret+"</dd>\n");
	 		}
	        out.write("</dl>");
	    }
	    catch (final IOException e)
	    {
	         e.printStackTrace();
	    } 
	}

}
