package jettyTiddlywiki.url;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import jettyTiddlywiki.response.AbnormalPrinter;
import jettyTiddlywiki.response.AbnormalPrinter.ResCode;


public enum URLHandler{
	INSTANCE;
	
	public boolean handle(final HttpServletRequest req, final HttpServletResponse res, final PC pc){
	 	final String url = req.getPathInfo();
        if (url == null){
        	AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
            return false;
        }
        if (url.endsWith("/"))
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
            return false;
        }
        int pos = 0;
        int c = 0;
        while (url.indexOf('/', pos) != -1)
        {
            c++;
            pos = url.indexOf('/', pos) + 1;
        }
        if (c != pc.pc)
        {
        	AbnormalPrinter.Singleton.print(res,req,ResCode.BadRequest);
            return false;
        }
        return true;
	}
	
	public enum PC{
		Wiki(1),Attachment(1),Comment(1),Diff(1),File(2),Raw(1);
		private PC(final int pc){
			this.pc = pc;
		}
		final int pc;
	}
}
